#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "nvram.h"
#include <linux/version.h>
int main(int argc,char **argv)
{
    FILE *wlanconf, *tmpconf;
    char *wordlist=NULL;
	char tmpbuf[76], tmp;
	int len=0, filelen=0;

	//printf("make_config -- DAT_NAME=%s\n", DAT_NAME);
	wlanconf = fopen(DAT_NAME, "r+");
	tmpconf = fopen(TMP_DAT_NAME, "w+");

	if( wlanconf == NULL)
	{
	    fprintf(stderr, "Can't open %s\n", DAT_NAME);
		return;
	}

//#ifdef RT2860STA

	nvram_set("SystemName","RalinkSTA");
	//fprintf(wlanconf, "#The word of \"Default\" must not be removed\n");
    //fprintf(wlanconf, "Default\n");
	memset(tmpbuf, 0x00, sizeof(tmpbuf));

	while (fscanf(wlanconf, "%c", &tmp) != EOF)
	{
		//printf("%c %d ", tmp, tmp);
		//find header section.
		if (filelen < 51)
		{
			fprintf(tmpconf, "%c", tmp);
			filelen++;
		}		
		else if(tmp != 0x3D) // =
		{
			tmpbuf[len++]= tmp;
		}
		else if(tmp == 0x3D)
		{
			int wordlistlen=0;
			int aetype=0; // auth, encryp
			
			//printf("0--tmpbuf=%s\n", tmpbuf);
			if(strcmp(tmpbuf, "CountryRegion") == 0)
			{
				wordlist = nvram_get("staCountryRegionBG");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "CountryRegionABand") == 0)
			{
				wordlist = nvram_get("staCountryRegionA");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;

			}
			else if(strcmp(tmpbuf, "WirelessMode") == 0)
			{
				wordlist = nvram_get("staWirelessMode");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "TxRate") == 0)
			{
				wordlist = nvram_get("staTxRate");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "BGProtection") == 0)
			{
				wordlist = nvram_get("staBGProtection");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "TxBurst") == 0)
			{
				wordlist = nvram_get("staTxBurst");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_OpMode") == 0)
			{
				wordlist = nvram_get("staHT_OpMode");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_BW") == 0)
			{
				wordlist = nvram_get("staHT_BW");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_GI") == 0)
			{
				wordlist = nvram_get("staHT_GI");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "HT_MCS") == 0)
			{
				wordlist = nvram_get("staHT_MCS");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)  // staHT_MCS is the least , so 
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			//wps, connected
			else if(strcmp(tmpbuf, "SSID") == 0)
			{				
				wordlist = nvram_get("staConnectedSSID");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "AuthMode") == 0)
			{
				wordlist = nvram_get("staConnectedAuth");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"OPEN\n");
				}
				else
				{
					aetype = atoi(wordlist);

					switch(aetype)
					{
						case 0x00: //open
							strcpy(wordlist, "OPEN");
							break;
						case 0x04: //wpapsk
							strcpy(wordlist, "WPAPSK");
							break;
						case 0x01: //SHARED
							strcpy(wordlist, "SHARED");
							break;
						case 0x03: //WPA
							strcpy(wordlist, "WPA");
							break;
						case 0x06: //WPA2
							strcpy(wordlist, "WPA2");
							break;
						case 0x07: //WPA2PSK
							strcpy(wordlist, "WPA2PSK");
							break;
						case 0x05: //WPANONE
							strcpy(wordlist, "WPANONE");
							break;			
						default:
							strcpy(wordlist, "OPEN");
							break;
					}
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "EncrypType") == 0)
			{
				wordlist = nvram_get("staConnectedEncryp");
				tmpbuf[len++] = tmp;
				if(strcmp(wordlist,"") == 0 || wordlist == NULL)
				{
					sprintf(&tmpbuf[len],"NONE\n");					
				}
				else
				{
					aetype = atoi(wordlist);
					switch(aetype)
					{
						case 0x01: //none
							strcpy(wordlist, "NONE");
							break;
						case 0x00: //WEP
							strcpy(wordlist, "WEP");
							break;
						case 0x04: //TKIP
							strcpy(wordlist, "TKIP");
							break;
						case 0x06: //AES
							strcpy(wordlist, "AES");
							break;
						default:
							strcpy(wordlist, "NONE");
							break;
					}
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key1Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey1Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key1Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey1Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key2Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey2Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key2Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey2Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key3Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey3Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key3Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey3Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key4Type") == 0)
			{
				wordlist = nvram_get("staConnectedKey4Type");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"0\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "Key4Str") == 0)
			{
				wordlist = nvram_get("staConnectedKey4Str");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "DefaultKeyID") == 0)
			{
				wordlist = nvram_get("staConnectedDefaultKeyId");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"1\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}
				
				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else if(strcmp(tmpbuf, "WPAPSK") == 0)
			{
				wordlist = nvram_get("staConnectedWpaPsk");
				tmpbuf[len++] = tmp;

				if(strcmp(wordlist,"") == 0)
				{
					sprintf(&tmpbuf[len],"\n");
				}
				else
				{
					sprintf(&tmpbuf[len],"%s\n", wordlist);
				}

				while (tmp != 0x0A)
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;
			}
			else
			{
				tmpbuf[len++] = tmp;
				while (tmp != 0x0A ){
					if (fscanf(wlanconf, "%c", &tmp) == EOF)
						break;

					tmpbuf[len++] = tmp;
				}
			}
			//printf("2--tmpbuf=%s\n", tmpbuf);
			fprintf(tmpconf, "%s", tmpbuf);
			memset(tmpbuf, 0x00, sizeof(tmpbuf));
			len=0;

		}
	}

#ifdef RT2860STA
	system("rm -rf /etc/Wireless/RT2860STA/RT2860STA.dat");
	system("mv /etc/Wireless/RT2860STA/RT2860STA.tmp /etc/Wireless/RT2860STA/RT2860STA.dat");
#else  //RT2870STA
	system("rm -rf /etc/Wireless/RT2860STA/RT2870STA.dat");
	system("mv /etc/Wireless/RT2870STA/RT2870STA.tmp /etc/Wireless/RT2870STA/RT2870STA.dat");
#endif
    fclose(wlanconf);
	fclose(tmpconf);
}	
